data Tree a = Empty | Node a (Tree a) (Tree a) deriving (Show)

myEmpty :: Tree Int
myEmpty = Empty

root :: Tree a -> a
root (Node elem _ _) = elem
root Empty = error "Tree is vide, banane"

left :: Tree a -> Tree a
left (Node _ ag _) = ag
left Empty = error "Tree is vide, banane"

right :: Tree a -> Tree a
right (Node _ _ ad) = ad
right Empty = error "Tree is vide, banane"

isEmpty :: Tree a -> Bool
isEmpty Empty = True
isEmpty _ = False

isLeaf :: Tree a -> Bool
isLeaf a =  not (isEmpty a) && (isEmpty (left a)) && (isEmpty (right a))

isLeaf' :: Tree a -> Bool
isLeaf' (Node _ Empty Empty) = True
isLeaf' _ = False

search :: (Eq a) => a -> Tree a -> Bool
search _ Empty = False
search x (Node elem ag ad) = (x == elem) || (search x ag) || (search x ad)

search' :: (Eq a) => a -> Tree a -> Bool
search' x t = not (isEmpty t) && (x == (root t)) || (search x (left t)) || (search x (right t))

searchOrd :: (Ord a) => a -> Tree a -> Bool
searchOrd _ Empty = False
searchOrd x (Node elem ag ad) = (x == elem) || if (x < elem) then (searchOrd x ag) else (searchOrd x ad)

numberOfNodes :: Tree a -> Int
numberOfNodes Empty = 0
numberOfNodes (Node _ ag ad) = 1 + (numberOfNodes ag) + (numberOfNodes ad) 

height :: Tree a -> Int
height Empty = 0
height (Node elem ag ad) = 1 + max (height ag) (height ad)

sumTree :: Integral a => Tree a -> a
sumTree Empty = 0
sumTree (Node elem ag ad) = elem + (sumTree ag) + (sumTree ad)

prefixe :: (Show a) => Tree a -> String
prefixe Empty = "[]"
prefixe (Node elem ag ad) = "[" ++ (show elem) ++ ", " ++ (prefixe ag) ++ ", " ++ (prefixe ad) ++ "]"

infixe :: (Show a) => Tree a -> String
infixe Empty = "[]"
infixe (Node elem ag ad) = "[" ++ (infixe ag) ++ ", " ++ (show elem) ++ ", " ++ (infixe ad) ++ "]"

postfixe :: (Show a) => Tree a -> String
postfixe Empty = "[]"
postfixe (Node elem ag ad) = "[" ++ (postfixe ag) ++ ", " ++ (postfixe ad) ++ ", " ++ (show elem) ++ "]"

prefixe' :: Tree a -> [a]
prefixe' Empty = []
prefixe' (Node elem ag ad) = elem:(prefixe' ag) ++ (prefixe' ad)

infixe' :: Tree a -> [a]
infixe' Empty = []
infixe' (Node elem ag ad) = (infixe' ag) ++ (elem:(infixe' ad))

postfixe' :: Tree a -> [a]
postfixe' Empty = []
postfixe' (Node elem ag ad) = (postfixe' ag) ++ (postfixe' ad) ++ [ elem ]

main = do
  let a = Node 21 (Node 8 Empty Empty) Empty
      b = Node 7 (Node 29 Empty Empty) (Node 13 Empty (Node 88 Empty Empty))
      c = Node 5 (Node 12 a Empty) b
      d = Node 55 (Node 30 (Node 23 Empty Empty) (Node 41 Empty Empty)) (Node 78 Empty (Node 88 Empty Empty))
      in do 
        print c
        print $ root c
        -- print $ root myEmpty
        print $ left c
        print $ right c
        print $ isEmpty myEmpty
        print $ isEmpty c
        print $ isLeaf c
        print $ isLeaf (left a)
        print $ isLeaf' c
        print $ isLeaf' (left a)
        print $ search 12 c
        print $ search 55 c
        print $ searchOrd 23 d
        print $ searchOrd 89 d
        print $ numberOfNodes c
        print $ height c
        print $ sumTree c
        putStrLn $ prefixe c
        putStrLn $ infixe c
        putStrLn $ postfixe c
        print $ prefixe' c
        print $ infixe' c
        print $ postfixe' c
        
        
        